#include <stdlib.h>
#include <allegro.h>
#include "051mc.h"

CIRCLE_T *circle_init(int new_x, int new_y, int new_radius,
		      int new_col, int new_xs, int new_ys)
{
    CIRCLE_T *temp;

    // Allocate memory for the circle. If unsuccessful, return NULL.
    temp = malloc(sizeof(CIRCLE_T));

    if (!temp)
	return NULL;

    temp->x = new_x;
    temp->y = new_y;
    temp->r = new_radius;
    temp->col = new_col;
    temp->xs = new_xs;
    temp->ys = new_ys;
    temp->dx = temp->dy = 0;

    return temp;
}

void circle_destroy(CIRCLE_T * circle)
{
    if (circle)
	free(circle);
}

void circle_draw(CIRCLE_T * circle, BITMAP * bmp)
{
    circlefill(bmp, circle->x, circle->y, circle->r, circle->col);

    circle->dx = circle->x;
    circle->dy = circle->y;
}

void circle_update(CIRCLE_T * circle)
{
    // First we update the position of the circle...
    circle->x += circle->xs;
    circle->y += circle->ys;

    // Now we see if it reached the maximum frame border

    if (circle->x > SCREEN_W - 5)
	circle->xs *= -1;

    if (circle->y > SCREEN_H - 5)
	circle->ys *= -1;

    if (circle->x < 5)
	circle->xs *= -1;

    if (circle->y < 5)
	circle->ys *= -1;
}

void circle_erase(CIRCLE_T * circle, BITMAP * bmp)
{
    circlefill(bmp, circle->dx, circle->dy, circle->r, 0);
}
