// Measuring the frame rate

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <allegro.h>
#include "0942.h"

int pixels_per_frame;
int end_example;

volatile int last_fps;
volatile int frame_counter;

BITMAP *dblbuffer;

void count_frames()
{
    last_fps = frame_counter;
    frame_counter = 0;
}

END_OF_FUNCTION(count_frames);

int main(void)
{
    allegro_init();
    init_example();

    while (end_example == 0) {

	if (keypressed())
	    end_example++;

	draw_screen();
	frame_counter++;
    }

    return 0;
}
END_OF_MAIN();

void draw_screen()
{
    int f;

    for (f = 0; f < pixels_per_frame; f++)
	dblbuffer->line[rand() % SCREEN_H][rand() % SCREEN_W] = rand() % 256;

    textprintf(dblbuffer, font, 0, 0, 15, "Frames per second: %d", last_fps);

    blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}

void init_example()
{
    int i;
    
    srand(time(NULL));

    if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
	allegro_message("Couldn't set gfx mode: %s\n", allegro_error);
	exit(1);
    }
    
    install_keyboard();
    install_timer();

    clear(screen);
    textout(screen, font, "How many pixels you want? Recommend 20000.", 0, 0, 15);
    textout(screen, font, "Press a key from 1 to 9.", 0, 10, 15);
    textout(screen, font, "I will create [KEY] * 10000 pixels.", 0, 20, 15);

    pixels_per_frame = 0;
    while (pixels_per_frame == 0) {
	for (i = KEY_1; i <= KEY_9; i++) {
	    if (key[i])
		pixels_per_frame = (1 + i - KEY_1) * 10000;
	}
    }
    clear_keybuf();

    LOCK_VARIABLE(last_fps);
    LOCK_VARIABLE(frame_counter);
    LOCK_FUNCTION(count_frames);
    install_int_ex(count_frames, BPS_TO_TIMER(1));

    end_example = last_fps = frame_counter = 0;

    dblbuffer = create_bitmap(320, 200);
    if (dblbuffer == NULL) {
	allegro_exit();
	allegro_message("Sorry, not enough memory");
	exit(1);
    }
    clear(dblbuffer);
}
